// cap_sts.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "cusb2.h"

#pragma warning( disable : 4996)

///	#define DEBUG_FW
//#define DEBUG_FW

#ifdef DEBUG_FW
u8 fw_iic[1024*8];
#else
u8 fw_iic[]=
#include "fw.inc"
#endif

#define CMD_EP6IN_START		0x50	//TS
#define	CMD_EP6IN_STOP		0x51	//TS
#define	CMD_EP2OUT_START	0x52	//TS-BACK
#define	CMD_EP2OUT_STOP		0x53	//TS-BACK
#define	CMD_PORT_CFG		0x54	//addr_mask, out_pins
#define	CMD_REG_READ		0x55	//addr	(return 1byte)
#define	CMD_REG_WRITE		0x56	//addr, value
#define	CMD_PORT_READ		0x57	//(return 1byte)
#define	CMD_PORT_WRITE		0x58	//value
#define	CMD_IFCONFIG		0x59	//value
#define	CMD_MODE_IDLE		0x5a
#define CMD_EP4IN_START		0x5b	//B-CAS
#define	CMD_EP4IN_STOP		0x5c	//B-CAS
#define	CMD_IR_CODE			0x5d	//val_l, val_h (0x0000:RBUF capture 0xffff:BWUF output)
#define CMD_IR_WBUF			0x5e	//ofs(0 or 64 or 128 or 192), len(max 64), data, ....
#define	CMD_IR_RBUF			0x5f	//ofs(0 or 64 or 128 or 192) (return 64byte)

#define BUF_LEN	(1024*64)
#define	QUE_NUM	16

#define	PIO_START	0x20
#define	PIO_IR_OUT	0x10
#define	PIO_IR_IN	0x08
#define PIO_TS_BACK	0x04

cusb2 *usb;
cusb2_tcb *tcb1;
cusb2_tcb *tcb2;

LONG cmd_len=0,ret_len=0;
u8	cmd[64];
u8  ret[64];
CCyUSBEndPoint *inep;
CCyUSBEndPoint *outep;

#define BCAS_PRE_TIME	15
#define BCAS_POST_TIME	0

time_t start_time = 0;
time_t end_time = 0;
bool bcas = true;
u32	bcascount = 50;	///s

FILE *wfp;
FILE *wfp2;
bool rec_end = false;
bool force_exit = false;

bool write_func(u8 *buf, u32 len){
	cmd[cmd_len++]=CMD_EP6IN_STOP;
	if(bcas == false) 
		cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	rec_end = true;
	return false;
}

bool write_bcas(u8 *buf, u32 len){
	printf("len=%02X buf=", len);
	u32	i;
	for(i=0;i<len;i++)
	{
	printf("%02X",buf[i]);
	}
	printf("\n");

//	if((!force_exit) && (now < end_time + BCAS_POST_TIME)) return true;
	if(bcascount--) return true;

	cmd[cmd_len++]=CMD_EP4IN_STOP;
	cmd[cmd_len++]=CMD_MODE_IDLE;
	usb->xfer(outep, cmd, cmd_len);
	cmd_len=0;
	rec_end = true;
	return false;
}


void ir_cmdtx(u16 *ircmd, s32 n){
	s32 i;
	s32 ir_wait = 600;
	for(i=0; i<n; i++){
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=(u8)ircmd[i];
		cmd[cmd_len++]=(u8)(ircmd[i] >> 8);
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		if(ircmd[i] == 0x04d8) 
			ir_wait = 300;	//3digit
		Sleep(ir_wait);
		//IRo͒~
		cmd[cmd_len++]=CMD_IR_CODE;
		cmd[cmd_len++]=0;
		cmd[cmd_len++]=0;
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;
		Sleep(100);
	}
}

u16 uniden_remocon(u8 *rbuf, s32 len){
	s32 i,j;
	u16 code = 0;

	//Interval time
	for(i = j = 0; i < len - 2*16; i++){
		if(rbuf[len-1-i] == 0xff){
			if(++j > 3) break;
		}
		else{
			j = 0;
		}
	}
	if(j > 3){
		//Header(1) == 0 (2300us)
		for(;i < len - 2*16; i++) if((rbuf[len-1-i] & 1) == 0) break;
		if((i == len - 2*16) || (rbuf[len-1-i] < 200/2))
			return 0;
		//Header(2) == 1 (1100us)
		i++;
		if(rbuf[len-1-i] < 80/2)
			return 0;
		//Header(3) == 0 (600us)
		i++;
		if(rbuf[len-1-i] > 80/2)
			return 0;
		i++;
		for(j = 0; j < 16; j++){
			code = code >> 1;
			if(rbuf[len-1-i] > 100/2)
				code |= 0x8000;
			i+=2;
		}
		return(code);
	}
	return(0);
}

static const char *def_tsfname = "test.ts2";
static const char *def_bcasfname = "test.bcs";

int _tmain(int argc, _TCHAR* argv[])
{
	s32 i;
	s32 sleep=0;
	time_t now;
	char *tsfname = NULL, tsfname_buf[256];
	char *bcasfname = NULL, bcasfname_buf[256];
	u8 fx2id = 0;
	u16 ir_cmd[16];
	s32 ir_cmd_num = 0;
	u16 ir_post_cmd[16];
	s32 ir_post_cmd_num = 0;
	u16 ir_base = 0x00;




#ifdef DEBUG_FW		//8051t@[ϊ ( iic -> inc )

	FILE *fp;
///	fopen_s(&fp, "fw\\fifo.iic","rb");
	fopen_s(&fp, "..\\fw\\fifo.iic","rb");
	//fopen_s(&fp, "fw\\fifo_sdcc.iic","rb");
	fread(fw_iic, 1, sizeof(fw_iic), fp);

	if(fopen_s(&wfp2, "..\\fw.inc", "w")){
		printf("File(fw.inc) open err.\n");
	}

	fseek( fp, 0L, SEEK_END );
	DWORD dwIicFileSize = ftell( fp );
	fseek( fp, 0L, SEEK_SET );

	fprintf(wfp2, "// Len = %02d \n", dwIicFileSize);
	fprintf(wfp2, "{\n");
 
	for(i=0; i< dwIicFileSize; i++)
	{
		fprintf(wfp2, "0x%02X,", fw_iic[i]);
	}

	fprintf(wfp2, "\n};");

#endif










	u32 cap_mb = 10;
	time( &now );			//bPʂŎ擾
	if(argc == 1){
		printf("TOMƏI܂\n");
//		exit(-1);
	}
	else{
		for(i=1; i<argc; i++){
			_mbslwr((unsigned char *)argv[i]);
			if(('0' <= argv[i][0]) && (argv[i][0] <= '9')){
				//
				if(strchr(argv[i], ':')!=NULL){//nn:nnw
					struct tm *nt;
					s32 st_h,st_m,en_h,en_m;
					nt = localtime( &now );	// tm \̌`ɕϊ
					if(sscanf(argv[i], "%d:%d-%d:%d", &st_h, &st_m, &en_h, &en_m) == 4){//폈
						if((st_h * 60 + st_m) < (nt->tm_hour * 60 + nt->tm_min)){
							//Ȃ̂24Ԓǉ
							st_h += 24;
							en_h += 24;
						}
						if((st_h * 60 + st_m) > (en_h * 60+ en_m))
							//It܂̂
							en_h += 24;
						//bH
						sleep = (st_h * 60*60 + st_m * 60) - (nt->tm_hour * 60*60 + nt->tm_min * 60 + nt->tm_sec);
						end_time = now + sleep + ((en_h * 60*60 + en_m * 60) - (st_h * 60*60 + st_m * 60));
						int min = (en_h * 60 + en_m) - (st_h * 60 + st_m);
						st_m = sleep - (sleep/(60*60))*(60*60);
						printf("%2.2d:%2.2d:%2.2d bォ%2.2d:%2.2d ԋL^܂B\n", sleep/(60*60), st_m/60 , sleep%60, min/60, min%60);
					}
				}
				else{
					char *s;
					int min = strtol(argv[i], &s, 10);
					end_time = now + min*60;
					printf("ݎ%2.2d:%2.2d ԋL^܂B\n", min/60, min%60);
				}
			}
			else if(argv[i][0] == 'p'){
				ir_cmd[ir_cmd_num++] = 0x048b + ir_base;						//dON
				ir_post_cmd[ir_post_cmd_num++] = 0x048c + ir_base;				//dOFF
			}
			else if((argv[i][0] == 'r')&&(isdigit(argv[i][1]))){
				char *s;
				ir_base = (u8)strtol(argv[i]+1, &s, 10);
				printf("Rԍ %d ɐݒ肵܂B\n", ir_base);
				ir_base = (ir_base - 1) * 0x80;
			}
			else if(argv[i][0] == '@'){
				//`l
				int n = 2;
				printf("`l[");
				if(argv[i][1] == 'b'){
					//BS
					printf("BS");
					ir_cmd[ir_cmd_num++] = 0x04e2 + ir_base;					//BS
					if((argv[i][3]==0)||(argv[i][4]==0)){
						if(argv[i][3] != 0){//10,11,12ch
							n = 4;
							printf("%s", argv[i]+2);
							if(argv[i][3] == '0')
								ir_cmd[ir_cmd_num++] = 0x0480 + ir_base;						//10ch
							else
								ir_cmd[ir_cmd_num++] = 0x04d1 + ir_base + (argv[i][3] - '1');	//11,12ch
						}
						else{
							n = 2;
						}
					}
					else{
						ir_cmd[ir_cmd_num++] = 0x04d8 + ir_base;				//3-digit
					}
				}
				else if(argv[i][1] == 'c'){
					//CS
					printf("CS");
					ir_cmd[ir_cmd_num++] = 0x04e3 + ir_base;					//CS
					if((argv[i][3]==0)||(argv[i][4]==0)){
						if(argv[i][3] != 0){//10,11,12ch
							n = 4;
							printf("%s", argv[i]+2);
							if(argv[i][3] == '0')
								ir_cmd[ir_cmd_num++] = 0x0480 + ir_base;						//10ch
							else
								ir_cmd[ir_cmd_num++] = 0x04d1 + ir_base + (argv[i][3] - '1');	//11,12ch
						}
						else{
							n = 2;
						}
					}
					else{
						ir_cmd[ir_cmd_num++] = 0x04d8 + ir_base;								//3-digit
					}
				}
				else{
					//nfW
					printf("nfW");
					ir_cmd[ir_cmd_num++] = 0x04d6 + ir_base;					//n
					ir_cmd[ir_cmd_num++] = 0;
					if(argv[i][2] != 0){//10,11,12ch
						n = 3;
						printf("%s", argv[i]+1);
						if(argv[i][2] == '0')
							ir_cmd[ir_cmd_num++] = 0x0480 + ir_base;						//10ch
						else
							ir_cmd[ir_cmd_num++] = 0x04d1 + ir_base + (argv[i][2] - '1');	//11,12ch
					}
					else{
						n = 1;
					}
				}
				while(argv[i][n] != 0){
					putchar(argv[i][n]);
					ir_cmd[ir_cmd_num++] = 0x0480 + ir_base + (argv[i][n] - '0');	//num
					n++;
				}
				printf("]\n");
			}
			else if(strcmp(argv[i], "b") == 0){
				//BCASOw
				bcas = true;
			}
			else if((argv[i][0] == 'i')&&(isdigit(argv[i][1]))&&(argv[i][2]==0)){
				//JFX2@IDw
				char *s;
				fx2id = (u8)strtol(argv[i]+1, &s, 10);
				printf("^[Qbg̃JIUSB FX2ID %d ɐݒ肵܂B\n", fx2id);
			}
			else{
				//t@C
				char *s;
				tsfname = tsfname_buf;
				bcasfname = bcasfname_buf;
				strcpy(tsfname, argv[i]);
				if(strchr(tsfname, '.') == NULL){
					strcat(tsfname, ".ts2");
				}
				strcpy(bcasfname, argv[i]);
				if((s = strchr(bcasfname, '.')) != NULL)
					*s = 0;
				strcat(bcasfname, ".bcs");
			}
		}
	}
	start_time = now + sleep;
	if(bcas){
		//BCASL^
		if(sleep != 0){
			sleep -= BCAS_PRE_TIME;
			if(sleep < 0) sleep = 0;
		}
		else{
			start_time += BCAS_PRE_TIME;
		}
	}
	usb = new cusb2(NULL);
///	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_FIFO"/*NULL*/))
	if(usb->fwload(fx2id, fw_iic,(u8 *)"FX2_FIF_"/*NULL*/))
	{
		inep = usb->get_endpoint(0x81);
		outep = usb->get_endpoint(0x01);

		//FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		cmd[cmd_len++]=CMD_PORT_CFG;
		cmd[cmd_len++]=0x00;								//no addr(addr_mask)
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//out_pins
		cmd[cmd_len++]=CMD_MODE_IDLE;
		cmd[cmd_len++]=CMD_IFCONFIG;
		cmd[cmd_len++]=0xE3;			//slave FIFO, IFCLK=48MHz, IFCLKo,  (Sync)[h
		//cmd[cmd_len++]=0xA3;			//slave FIFO, IFCLK=30MHz, IFCLKo,  (Sync)[h
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;

//		tcb1 = usb->start_thread(0x86, BUF_LEN, QUE_NUM, write_func);

		if(bcas){
			tcb2 = usb->start_thread(0x84, 512, 1, write_bcas);
		}

//		cmd[cmd_len++]=CMD_EP6IN_START;
		if(bcas)
			cmd[cmd_len++]=CMD_EP4IN_START;
		cmd[cmd_len++]=CMD_PORT_WRITE;
		cmd[cmd_len++]=PIO_START|PIO_IR_OUT|PIO_TS_BACK;	//START=1
		usb->xfer(outep, cmd, cmd_len);
		cmd_len=0;

		for(;;){
			u8 ir_rbuf[128];
			u16 code;

			cmd[cmd_len++]=CMD_IR_RBUF;
			cmd[cmd_len++]=0;	//ŏ64byte̓ItZbg0
			usb->xfer(outep, cmd, cmd_len);
			cmd_len=0;
			ret_len=64;
			usb->xfer(inep, ir_rbuf, ret_len);

			cmd[cmd_len++]=CMD_IR_RBUF;
			cmd[cmd_len++]=64;	//64byte̓ItZbg64(128,192 ő256byte܂Ŏ擾\j
			usb->xfer(outep, cmd, cmd_len);
			cmd_len=0;
			ret_len=64;
			usb->xfer(inep, ir_rbuf + 64, ret_len);
			
			code = uniden_remocon(ir_rbuf, 128);	//oCiIRf[^jf̃RR[hɕϊ

			if(code == 0x496 + ir_base){	//BACK
				force_exit = true;
				printf("I\n");
			}
			else{
				//printf("IR CODE = %4.4X\n", code);
			}

			Sleep(100);

			if(rec_end)
				break;
		}
		if(bcas){
			usb->delete_thread(tcb2);
		}

	}
	else{
		printf("^[Qbg̃JIUSB FX2Fł܂B\n");
	}
	delete usb;
	return 0;
}

